%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%   Multithreading demo
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clc
clear

mex M_BFilter.cpp

ima=imread('cameraman.tif');
ima=double(ima);

% add some noise 

level=15;
nima=ima + level*randn(size(ima));

% bilateral filter parameters

ratio=5;       % radius of the search area
sigmaS=5;      % regulates the importance of geometrical distance
sigmaI=level;  % regulates the importance of intensity distance 
               % (normally the best choice is the noise standard devaition)

%NC=feature('numCores');
NC=4;

for i=1:NC*2
    
tic
fima=M_BFilter(nima,ratio,sigmaS,sigmaI,i);
time(i)=toc

end

clf
plot(time)
xlabel('Number of threads')
ylabel('Time (secs)')
